
// TMSStudioView.cpp : implementation of the CTMSStudioView class
//

#include "stdafx.h"
// SHARED_HANDLERS can be defined in an ATL project implementing preview, thumbnail
// and search filter handlers and allows sharing of document code with that project.
#ifndef SHARED_HANDLERS
#include "TMSStudio.h"
#endif

#include "TMSStudioDoc.h"
#include "TMSStudioView.h"

#include "CommandTarget.h"

#include "AbstractDlgScore.h"
#include "DlgScoreLT.h"
#include "DlgScoreLH.h"
#include "DlgScoreRT.h"
#include "DlgScoreRH.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif



#define CONTROL_WIDTH	100
#define CONTROL_HEIGHT	50
#define WAVE_HEIGHT		100





// CTMSStudioView

IMPLEMENT_DYNCREATE(CTMSStudioView, CView)

BEGIN_MESSAGE_MAP(CTMSStudioView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CTMSStudioView::OnFilePrintPreview)
	ON_WM_CONTEXTMENU()
	ON_WM_RBUTTONUP()
	ON_MESSAGE(WM_MSG_SENDUPDATE, OnMsgUpdate)
END_MESSAGE_MAP()

// CTMSStudioView construction/destruction

CTMSStudioView::CTMSStudioView()
{
	// TODO: add construction code here

}

CTMSStudioView::~CTMSStudioView()
{
}

BOOL CTMSStudioView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CTMSStudioView drawing

void CTMSStudioView::OnDraw(CDC* /*pDC*/)
{
	CTMSStudioDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here
}


// CTMSStudioView printing


void CTMSStudioView::OnFilePrintPreview()
{
#ifndef SHARED_HANDLERS
	AFXPrintPreview(this);
#endif
}

BOOL CTMSStudioView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CTMSStudioView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CTMSStudioView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CTMSStudioView::OnRButtonUp(UINT /* nFlags */, CPoint point)
{
	ClientToScreen(&point);
	OnContextMenu(this, point);
}

void CTMSStudioView::OnContextMenu(CWnd* /* pWnd */, CPoint point)
{
#ifndef SHARED_HANDLERS
	theApp.GetContextMenuManager()->ShowPopupMenu(IDR_POPUP_EDIT, point.x, point.y, this, TRUE);
#endif
}


// CTMSStudioView diagnostics

#ifdef _DEBUG
void CTMSStudioView::AssertValid() const
{
	CView::AssertValid();
}

void CTMSStudioView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTMSStudioDoc* CTMSStudioView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTMSStudioDoc)));
	return (CTMSStudioDoc*)m_pDocument;
}
#endif //_DEBUG


// CTMSStudioView message handlers


void CTMSStudioView::OnInitialUpdate()
{
	CRect rtClientRect;
	GetClientRect(rtClientRect);
	//GetWindowRect(rtClientRect);

	m_pDlgScoreLT = new CDlgScoreLT;
	m_pDlgScoreLT->Create( IDD_SCORE_LT,this );
	m_pDlgScoreLT->ShowWindow( SW_SHOW );
	m_pDlgScoreLT->MoveWindow( CONTROL_WIDTH,WAVE_HEIGHT,rtClientRect.Width(),50,TRUE );
	
	m_pDlgScoreLH = new CDlgScoreLH;
	m_pDlgScoreLH->Create( IDD_SCORE_LH,this );
	m_pDlgScoreLH->ShowWindow( SW_SHOW );
	m_pDlgScoreLH->MoveWindow( CONTROL_WIDTH,WAVE_HEIGHT+CONTROL_HEIGHT,rtClientRect.Width(),50,TRUE );

	m_pDlgScoreRT = new CDlgScoreRT;
	m_pDlgScoreRT->Create( IDD_SCORE_RT,this );
	m_pDlgScoreRT->ShowWindow( SW_SHOW );
	m_pDlgScoreRT->MoveWindow( CONTROL_WIDTH,WAVE_HEIGHT+CONTROL_HEIGHT*2,rtClientRect.Width(),50,TRUE );

	m_pDlgScoreRH = new CDlgScoreRH;
	m_pDlgScoreRH->Create( IDD_SCORE_RH,this );
	m_pDlgScoreRH->ShowWindow( SW_SHOW );
	m_pDlgScoreRH->MoveWindow( CONTROL_WIDTH,WAVE_HEIGHT+CONTROL_HEIGHT*3,rtClientRect.Width(),50,TRUE );



	CView::OnInitialUpdate();
}
/*
BOOL CInternalViewBase::Create( CLocalDocAbstract* pLocalDoc, CWnd* pParentWnd )
{
 // Asserting parameters
 // ASSERT( pLocalDoc != NULL );  // ƹ ⵵   , empty doc   ִ.
 ASSERT( pParentWnd != NULL );
 ASSERT( ::IsWindow( pParentWnd->m_hWnd ) );

 // store the local document pointer for later use
 m_pLocalDoc = pLocalDoc;

 // window creation !
 return CWnd::Create( NULL, NULL, AFX_WS_DEFAULT_VIEW, CRect(0, 0, 0, 0), pParentWnd, AFX_IDW_PANE_FIRST, NULL);
}
*/

BOOL CTMSStudioView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext)
{
	CCommandTarget::ms_wndObserver = this;
	
	return CView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}


BOOL CTMSStudioView::PreTranslateMessage(MSG* pMsg)
{

	return CView::PreTranslateMessage(pMsg);
}

//WM_MSG_SENDUPDATE  ޼ ó Լ
LONG CTMSStudioView::OnMsgUpdate(WPARAM wParam, LPARAM lParam)
{
	UINT nId = (UINT)wParam;
	const CUpdateParam* pActualParam = reinterpret_cast<CUpdateParam*>( lParam );


	//PreProcessMessage  Broadcastؾ ϸ TRUE  ޴´.
	if( PreProcessMessage( nId, pActualParam ) )
	{
		BroadcastMessage( nId, pActualParam );
	}


	
	return 0;
}


BOOL CTMSStudioView::PreProcessMessage(UINT nId, const CUpdateParam* pActualParam)
{
	
	if( nId == WM_MSG_TSM_TEST )
	{
		const CUpdateParam_Test* pParam = static_cast<const CUpdateParam_Test*>( pActualParam );
		if( pParam )
		{
			CString strTmp = pParam->m_strTmp;
			AfxMessageBox(strTmp);
		}
		
		return FALSE;
	}
	else if( nId == WM_MSG_TSM_TEST2 )
	{
		AfxMessageBox(_T("I'm gonna broadcast!"));

		return TRUE;
	}

	//εĳƮ  .
	return FALSE;
}


BOOL CTMSStudioView::BroadcastMessage(UINT nId, const CUpdateParam* pActualParam)
{
	POSITION pos = CCommandTarget::ms_listTarget.GetHeadPosition();
	
	while( pos )
	{
		CCommandTarget* target = CCommandTarget::ms_listTarget.GetNext( pos );
		if( target )
			target->OnUpdate( nId, pActualParam );
	}
	




	return FALSE;
}

